<template>
  <div v-if="nocMessages.length">
    <b-alert
      v-for="(message, index) in nocMessages"
      :key="index"
      model-value
      show
      dismissible
      :variant="getBannerVariant(message.type)"
      @closed="hideMessage(message.id)"
    >
      <i18n-t
        scope="global"
        :keypath="`banner.noc.text.${message.type}`"
        tag="p"
      >
        <template #nocPortal>
          <a :href="message.href ?? undefined" target="_blank">
            <i>{{ $t("banner.noc.nocPortal") }}</i>
          </a>
        </template>
      </i18n-t>
    </b-alert>
  </div>
</template>

<script lang="ts">
import { defineComponent, computed } from "vue";
import { useSystemStatusStore } from "@/store/systemStatus";
import { mapMessageTypeToBannerVariant } from "@/util/messageTypeMap";
import type { MessageType } from "@coscine/api-client/dist/types/Coscine.Api";
import type { BaseColorVariant } from "bootstrap-vue-next/dist/src/types";

export default defineComponent({
  setup() {
    const systemStatusStore = useSystemStatusStore();

    /**
     * Computes the list of visible NOC (Network Operations Center) messages.
     * @returns {MessageDto[]} The list of visible NOC messages.
     */
    const nocMessages = computed(() => systemStatusStore.visibleNocMessages);

    /**
     * Hides a NOC message by its ID.
     * @param {string | undefined} id - The ID of the message to hide.
     */
    const hideMessage = (id?: string) => {
      if (id) systemStatusStore.hideMessage(id);
    };

    /**
     * Maps a message type to a Bootstrap Vue variant.
     * @param {MessageType | undefined} type - The type of the NOC message.
     * @returns {keyof BaseColorVariant | null | undefined} The corresponding Bootstrap Vue variant.
     */
    const getBannerVariant = (
      type?: MessageType,
    ): keyof BaseColorVariant | null | undefined => {
      return mapMessageTypeToBannerVariant(type);
    };

    return {
      nocMessages,
      hideMessage,
      getBannerVariant,
    };
  },
});
</script>

<style scoped></style>
